#proximal_distal_REs.py, argv[1] = gff file, argv[2] = peaks bed file, argv[3] = output files header prefix, argv[4] = proximity range
import sys
import numpy as np

P_RANGE = int(sys.argv[4])

header = sys.argv[3]
proximal = open(header+'.proximal_peaks.bed', 'w')
distal = open(header+'.distal_peaks.bed', 'w')

TSS = []
indexes = {}

for line in open(sys.argv[1], 'r'): # load gene annotations into scaffold indexed list
    if '#' in line:
        continue
    chrom, maker, gene, start, stop, dot, orient, dot2, ID = line.split('\t')
    if chrom in indexes.keys():
        index = indexes[chrom]
    else:
        index = len(TSS)
        TSS.append([])
        indexes[chrom] = index
    if orient == '+':
        t_start = int(start)
    elif orient == '-':
        t_start = int(stop)
    else:
        print "Orient error!"
    add = t_start
    TSS[index].append(add)

for line in open(sys.argv[2], 'r'):
    chrom, start, stop, pile, fold_change = line.split('\t')
    index = indexes[chrom]
    array = np.asarray(TSS[index])
    if abs((array[abs(np.abs((array)-int(start)).argmin())]) - int(start)) < P_RANGE: # check forward strand proximal elements
        proximal.write(line)
    elif abs((array[abs(np.abs((array)-int(start)).argmin())]) - int(stop)) < P_RANGE: # check reverse strand proximal elements
        proximal.write(line)
    else:
        distal.write(line)
proximal.close()
distal.close()
